/*
 * SPDX-FileCopyrightText: 2022 Institute Rhea <eduard.filipas@rhea.si>
 *
 * SPDX-License-Identifier: EUPL-1.2
 */

#include "DialogNumberFunct.h"

DialogNumberFunct::DialogNumberFunct() : Gtk::Window() {

	lblPref->set_text(lang->getText("txtDialog_lblPref"));
	lblStep->set_text(lang->getText("txtDialog_lblStep"));
	lblPost->set_text(lang->getText("txtDialog_lblPost"));

	btnSave->set_label(lang->getText("txtDialog_btnSave"));
	btnSave->signal_clicked().connect(sigc::mem_fun(*this, &DialogNumberFunct::btnSaveOnClick));

	tvPrefix->set_size_request(70,25);
	tvStep->set_size_request(70,25);
	tvPostfix->set_size_request(70,25);

	boxPref->append(*lblPref);
	boxPref->append(*tvPrefix);

	boxStep->append(*lblStep);
	boxStep->append(*tvStep);

	boxPost->append(*lblPost);
	boxPost->append(*tvPostfix);

	mainBox->append(*boxPref);
	mainBox->append(*boxStep);
	mainBox->append(*boxPost);
	mainBox->append(*btnSave);

	this->set_child(*mainBox);

}

DialogNumberFunct::~DialogNumberFunct() {
	// TODO Auto-generated destructor stub
}

void DialogNumberFunct::fill(std::vector<std::string>* values, Gtk::Button* btn) {
	returnBtn = btn;
	options = values;
	tvPrefix->get_buffer()->set_text(options->at(0));
	tvStep->get_buffer()->set_text(options->at(1));
	tvPostfix->get_buffer()->set_text(options->at(2));

}

void DialogNumberFunct::btnSaveOnClick(){

	std::string tmp = "";
	options->clear();
	options->push_back(tvPrefix->get_buffer()->get_text());
	options->push_back(tvStep->get_buffer()->get_text());
	options->push_back(tvPostfix->get_buffer()->get_text());

	tmp += tvPrefix->get_buffer()->get_text() + " " +tvStep->get_buffer()->get_text() + " " + tvPostfix->get_buffer()->get_text() ;

	returnBtn->set_label(tmp);
	close();
}
