/*
 * SPDX-FileCopyrightText: 2022 Institute Rhea <eduard.filipas@rhea.si>
 *
 * SPDX-License-Identifier: EUPL-1.2
 */

#ifndef GUI_DIALOGNUMBERFUNCT_H_
#define GUI_DIALOGNUMBERFUNCT_H_

#include "gtkmm.h"
#include "../main/Global.h"
#include "main/LanguagePack.h"

class DialogNumberFunct : public Gtk::Window {
private:
	Global* global = Global::getInstance();
	LanguagePack* lang = LanguagePack::getInstance();
	Gtk::Box* mainBox = new Gtk::Box(Gtk::Orientation::HORIZONTAL);
	Gtk::Box* boxPref = new Gtk::Box(Gtk::Orientation::VERTICAL);
	Gtk::Box* boxStep = new Gtk::Box(Gtk::Orientation::VERTICAL);
	Gtk::Box* boxPost = new Gtk::Box(Gtk::Orientation::VERTICAL);
	Gtk::Label* lblPref = new Gtk::Label();
	Gtk::Label* lblStep = new Gtk::Label();
	Gtk::Label* lblPost = new Gtk::Label();
	Gtk::TextView* tvPrefix = new Gtk::TextView();
	Gtk::TextView* tvPostfix = new Gtk::TextView();
	Gtk::TextView* tvStep = new Gtk::TextView();
	Gtk::Button* btnSave = new Gtk::Button("Shrani");
	Gtk::Button* returnBtn = {nullptr};
	void btnSaveOnClick();

public:
	std::vector<std::string>* options = {};
	DialogNumberFunct();
	virtual ~DialogNumberFunct();
	void fill(std::vector<std::string>* values, Gtk::Button* btn);


};

#endif /* GUI_DIALOGNUMBERFUNCT_H_ */
