/*
 * SPDX-FileCopyrightText: 2022 Institute Rhea <eduard.filipas@rhea.si>
 *
 * SPDX-License-Identifier: EUPL-1.2
 */

#ifndef GUI_DIALOGOPTIONS_H_
#define GUI_DIALOGOPTIONS_H_

#include "gtkmm.h"
#include "cbColumns/StringColumns.h"
#include "../rhea/ComboBox/ComboBox.h"
#include "../main/Global.h"
#include "main/LanguagePack.h"

class DialogOptions : public Gtk::Window {
protected:
	LanguagePack* lang = LanguagePack::getInstance();
	Global* global = Global::getInstance();
	int row = -1;
	std::vector<std::string*> myTemplates= {};
	Gtk::Box* mainBox = new Gtk::Box(Gtk::Orientation::VERTICAL);
	Gtk::Box* optItems = new Gtk::Box(Gtk::Orientation::VERTICAL);
	Gtk::Button* btnAdd = new Gtk::Button("Dodaj");
	Gtk::Button* btnSave = new Gtk::Button("Shrani");
	Gtk::Button* btnAddColumn = new Gtk::Button("Dodaj kolono");
	Gtk::Box* columnsBox =new Gtk::Box(Gtk::Orientation::VERTICAL);
	Gtk::Box* addSaveBox = new Gtk::Box(Gtk::Orientation::HORIZONTAL);
	Gtk::Button* returnBtn = {nullptr};
	StringColumns stringColumns;
    Glib::RefPtr<Gtk::ListStore> templateList = Gtk::ListStore::create(stringColumns);
    Glib::RefPtr<Gtk::ListStore> columnList = Gtk::ListStore::create(stringColumns);
	std::vector<Gtk::TextView*> items = {};
	std::vector<Gtk::TextView*> gridColumns = {};
	rhea::ComboBox<StringColumns>* cmbTemplate = new rhea::ComboBox<StringColumns>();
	rhea::ComboBox<StringColumns>* cmbCol1 = new rhea::ComboBox<StringColumns>();
	rhea::ComboBox<StringColumns>* cmbCol2 = new rhea::ComboBox<StringColumns>();
	rhea::ComboBox<StringColumns>* cmbCol3 = new rhea::ComboBox<StringColumns>();
	void cmbTemplateOnChange( rhea::ComboBox<StringColumns>* cmb, Gtk::TreeRow oldChoice, Gtk::TreeRow newChoice);
	void btnRemoveOnClick(Gtk::Button *btn, Gtk::TextView *tv,int row);
	void btnAddOnClick();
	void btnSaveOnClick();
	void setCmbBoxColumns(std::string &templ,rhea::ComboBox<StringColumns>* cmbCol);
	void fillColumnList (int id);

public:

	std::vector<std::string>* options = {};
	DialogOptions();
	~DialogOptions();
	void fill(std::vector<std::string*> templateOptions, std::vector<std::string>* values,Gtk::Button* btn);

};

#endif /* GUI_DIALOGOPTIONS_H_ */
