/*
 * SPDX-FileCopyrightText: 2022 Institute Rhea <eduard.filipas@rhea.si>
 *
 * SPDX-License-Identifier: EUPL-1.2
 */

#include "DialogOptionsGrid.h"
#include <iostream>

DialogOptionsGrid::DialogOptionsGrid() : DialogOptions() {
	btnAddColumn->signal_clicked().connect(sigc::mem_fun(*this, &DialogOptionsGrid::btnAddColumnOnClick));
	columnsBox->append(*btnAddColumn);
	optItems->prepend(*columnsBox);
}

DialogOptionsGrid::~DialogOptionsGrid() {
	// TODO Auto-generated destructor stub
}

void DialogOptionsGrid::btnRemoveColumnOnClick(Gtk::Button *btn, Gtk::TextView *tv) {
	btn->get_parent()->hide();
}

void DialogOptionsGrid::btnAddColumnOnClick() {
	Gtk::Box* colItem = new Gtk::Box(Gtk::Orientation::HORIZONTAL);
	Gtk::TextView* tv = new Gtk::TextView();
	tv->set_size_request(250, 35);
	tv->set_editable(true);
	tv->set_focusable(true);
	tv->set_focus_on_click(true);
	gridColumns.push_back(tv);

	Gtk::Button* btn = new Gtk::Button();
	btn->set_label(lang->getText("txtDialog_btnRemove"));
	btn->signal_clicked().connect(sigc::bind(sigc::mem_fun(*this, &DialogOptionsGrid::btnRemoveColumnOnClick),btn,tv));
	colItem->append(*tv);
	colItem->append(*btn);
	colItem->insert_before(*columnsBox,*btnAddColumn);
}
