/*
 * SPDX-FileCopyrightText: 2022 Institute Rhea <eduard.filipas@rhea.si>
 *
 * SPDX-License-Identifier: EUPL-1.2
 */

#ifndef GUI_FRMABOUT_H_
#define GUI_FRMABOUT_H_

#include "gtkmm.h"
#include "main/LanguagePack.h"

class FrmAbout final : public Gtk::Frame {
private:
	std::string grunfVersion = "1.5";
	LanguagePack* lang = LanguagePack::getInstance();
	Gtk::Box* box = new Gtk::Box(Gtk::Orientation::VERTICAL);
	Gtk::Box* main = new Gtk::Box(Gtk::Orientation::VERTICAL);
	Gtk::Box* content = new Gtk::Box(Gtk::Orientation::VERTICAL);
	Gtk::Box* contentImage = new Gtk::Box(Gtk::Orientation::HORIZONTAL);
	Gtk::Label* version = new Gtk::Label();
	Gtk::Label* author = new Gtk::Label();
	Gtk::Label* licence = new Gtk::Label();

public:
	FrmAbout();
	virtual ~FrmAbout();
    void onActivate();
    bool onClose();
};

#endif /* GUI_FRMABOUT_H_ */
