/*
 * SPDX-FileCopyrightText: 2022 Institute Rhea <eduard.filipas@rhea.si>
 *
 * SPDX-License-Identifier: EUPL-1.2
 */

#ifndef GUI_FRMSETTINGS_H_
#define GUI_FRMSETTINGS_H_

#include "gtkmm.h"
#include "main/LanguagePack.h"
#include "rhea/SqlLite/DbConn.h"

class FrmSettings : public Gtk::Frame {
private:
	Glib::RefPtr<Gtk::CssProvider> cssProvider = Gtk::CssProvider::create();
    LanguagePack* lang = LanguagePack::getInstance();
    rhea::DbConn* dbConn = rhea::DbConn::getInstance();
    Gtk::Box* mainBox = new Gtk::Box(Gtk::Orientation::VERTICAL);
    Gtk::Label* labelLang = new Gtk::Label();
	Gtk::CheckButton* chkSi  = new Gtk::CheckButton();
	Gtk::CheckButton* chkHr  = new Gtk::CheckButton();
	Gtk::CheckButton* chkBih = new Gtk::CheckButton();
	Gtk::CheckButton* chkEn  = new Gtk::CheckButton();
	Gtk::CheckButton* chkDe  = new Gtk::CheckButton();
	Gtk::CheckButton* chkFr  = new Gtk::CheckButton();
	Gtk::CheckButton* chkIt  = new Gtk::CheckButton();
    void onChkPressed();
public:
	FrmSettings();
	virtual ~FrmSettings();
	void onActivate();
	bool onClose();
};

#endif /* GUI_FRMSETTINGS_H_ */
