/*
 * SPDX-FileCopyrightText: 2022 Institute Rhea <eduard.filipas@rhea.si>
 *
 * SPDX-License-Identifier: EUPL-1.2
 */

#ifndef GUI_FRMTEMPLDATA_H
#define GUI_FRMTEMPLDATA_H

#include "ColumnW.h"
#include "../po/Template.h"
#include "../po/TemplateData.h"
#include "FrameBase.h"
#include "cbColumns/StringColumns.h"
#include "../rhea/ComboBox/ComboBox.h"
#include "../rhea/PickupDT/PickupDT.h"
#include "../main/Global.h"
#include "../rhea/FilesInBox/FilesInBox.h"
#include "WndImportTD.h"
#include "WndExportTD.h"
#include <libxml/parser.h>
#include <libxml/tree.h>

class FrmTemplData : public FrameBase<TemplateData> {
private:
	Template* tmpl = new Template();
	StringColumns stringColumns;
	void onListingGridClick(rhea::GridCell* cell) override;
	std::string dataListing (int col,int row) override;
	Global* global = Global::getInstance();
	rhea::FilesInBox* filesBox = new rhea::FilesInBox();
	void ReplaceText(xmlNode * aNnode, rhea::ListedMap<std::string, std::string>* values);
	void ExpandGrid(xmlNode * aNode,std::vector<std::string> &grids);
public:
	bool refreshOptions = false;
	Gtk::Label* lblName     = new Gtk::Label();
	FrmTemplData(std::string templateId);
	~FrmTemplData();
	void btnRefreshOptionCmb(rhea::ComboBox<StringColumns>* cmb, Column* cl);
	void btnRefreshOptionChk(Gtk::Widget* chkBox, std::vector<std::string> options, bool group, bool refresh = false);
	void getListing() override;
    void populateGUI() override;
    TemplateData* populatePojo(rhea::DbResultSet* res,long row = -1) override;
    void setDataOnOldPojo(TemplateData po) override;
	long setId() override;
	void onNew() override;
    void onSave() override;
    void onDelete() override;
    bool onClose() override;
    void onActivate() override;
    void populateVersions(TemplateData* obj, std::vector<TemplateData*> &list) override;
    void populateTemplateFiles(TemplateData* myPo) override;
    void fillImport() override;
    void fillExport() override;
    void getDataAsOptions(std::vector<std::string> &options, std::vector<std::string> &valOptions);
};


#endif //GUI_FRMTEMPLDATA_H
