/*
 * SPDX-FileCopyrightText: 2022 Institute Rhea <eduard.filipas@rhea.si>
 *
 * SPDX-License-Identifier: EUPL-1.2
 */

#ifndef GUI_FRMSETTINGS_H
#define GUI_FRMSETTINGS_H

#include "ColumnW.h"
#include "po/Template.h"
#include "rhea/SqlLite/DbConn.h"
#include "rhea/ComboBox/ComboBox.h"
#include "rhea/Grid/Grid.h"
#include "rhea/ListedMap/ListedMap.h"
#include "cbColumns/StringColumns.h"
#include "rhea/ComboBox/ComboBox.h"
#include "rhea/FilesInBox/FilesInBox.h"
#include "../main/Global.h"
#include "gtkmm.h"
#include "DialogOptions.h"
#include "DialogOptionsGrid.h"
#include "DialogNumberFunct.h"

class FrmTemplDef : public Gtk::Frame  {
private:
    LanguagePack* lang = LanguagePack::getInstance();
    Global* global = Global::getInstance();
    rhea::ListedMap<std::string, Template*>  templates = {};
    void OnListGridClick(rhea::GridCell* cell);
    Gtk::Widget* connectWidgetList(int col, int row);
    void OnDefGridClick(rhea::GridCell* cell);
    Gtk::Widget* connectWidgetDef(int col, int row);
    int selectedTemplate = {-1};
    Gtk::Label* lblForTemplate = new Gtk::Label();
    Gtk::Box* boxListedTemplates = new Gtk::Box(Gtk::Orientation::VERTICAL);
    Gtk::Box* boxToDetais= new Gtk::Box(Gtk::Orientation::VERTICAL);
    Gtk::Box* boxTemplDef = new Gtk::Box(Gtk::Orientation::VERTICAL);
    Gtk::Box* boxButtonsDef = new Gtk::Box(Gtk::Orientation::HORIZONTAL);
    Gtk::Box* boxButtonBox = new Gtk::Box(Gtk::Orientation::HORIZONTAL);
    Gtk::Button* btnAddTemplate = new Gtk::Button("Dodaj template");
    Gtk::Button* btnAddColumn = new Gtk::Button("Dodaj atribut");
    Gtk::Button* btnSaveColumns = new Gtk::Button("Shrani Atribute");
    Gtk::Button* btnDetails = new Gtk::Button("Podrobnosti");
    Gtk::Button* btnBack = new Gtk::Button("Nazaj");

    rhea::FilesInBox* fileBox = new rhea::FilesInBox();

    StringColumns stringColumns;
    Glib::RefPtr<Gtk::ListStore> typeList = Gtk::ListStore::create(stringColumns);
    Glib::RefPtr<Gtk::ListStore> objectList = Gtk::ListStore::create(stringColumns);
    Template* populateTemplates(rhea::DbResultSet* res);
    long setId();
    void btnDetailsOnClick ();
    void btnToggleListOnClick(Gtk::CheckButton *chk, int row);
    void btnDeleteListOnClick(Gtk::Button *btn, int row);
    void addFile(rhea::GridCell* cell, std::string fileName);
    void removeFile(rhea::GridCell* cell, std::string fileName);
    void btnSaveListOnClick(Gtk::Button *btn, int row);
    void btnAddTemplateClick();
    void btnAddColumnClick();
    void cmbTypeOnChange( rhea::ComboBox<StringColumns>* cmb, Gtk::TreeRow oldChoice, Gtk::TreeRow newChoice);
    void insertTemplate(Template* templ);
    void updateTemplate(Template* templ);
    void btnSaveColumnsClick();
    void btnOptionsOnClick(Gtk::Button *btn, int row);
    void btnDelColumnOnClick(Gtk::Button *btn, int row);
    void btnBackClick();
    void getOtherTemplates(std::vector<std::string*> &alternatives);
    void btnModifierOnClick (Gtk::Button *btn, int row);

public:
    Glib::RefPtr<Gtk::CssProvider> cssProvider = Gtk::CssProvider::create();
    rhea::DbConn* dbConn = rhea::DbConn::getInstance();
    Gtk::Box* box = new Gtk::Box(Gtk::Orientation::HORIZONTAL);
    rhea::Grid* templateList = new rhea::Grid();
    rhea::Grid* templateDef = new rhea::Grid();


    FrmTemplDef();
    ~FrmTemplDef();
    void onActivate();
    bool onClose();

};


#endif //GUI_FRMSETTINGS_H
