/*
 * SPDX-FileCopyrightText: 2022 Institute Rhea <eduard.filipas@rhea.si>
 *
 * SPDX-License-Identifier: EUPL-1.2
 */

#ifndef GUI_WNDEXPORT_H_
#define GUI_WNDEXPORT_H_

#include "gtkmm.h"
#include <string>
#include "../rhea/ListedMap/ListedMap.h"
#include "../rhea/Grid/Grid.h"
#include "../rhea/File/File.h"
#include "main/LanguagePack.h"

template<class T> class WndExport : public Gtk::Window {
private:

	Gtk::Box*    mainBox    = new Gtk::Box(Gtk::Orientation::VERTICAL);
	Gtk::Box*    fileBox    = new Gtk::Box(Gtk::Orientation::HORIZONTAL);
	Gtk::Box*    bottomBox  = new Gtk::Box(Gtk::Orientation::HORIZONTAL);
	Gtk::Button* btnExport  = new Gtk::Button("Export");
	Gtk::Label*  lblFile    = new Gtk::Label();
	Gtk::Button* btnFile    = new Gtk::Button("Save as");
	void onDialogResponse(int response_id, Gtk::FileChooserDialog* dialog);
	virtual void onExportClick() = 0;
	void onFileClick();
protected:
	LanguagePack* lang = LanguagePack::getInstance();
	Gtk::Label*  lblMessage = new Gtk::Label();
public:
	rhea::File* file = new rhea::File();
	rhea::Grid* fieldGrid                 = new rhea::Grid();
	rhea::ListedMap<std::string, T*>* map = {};
	WndExport();
	virtual ~WndExport();
	virtual void fill (T* myPo, rhea::ListedMap<std::string, T*>* myMap ) = 0;
	virtual Gtk::Widget* getListing(int col,int row) = 0;
};

#include "WndExport.cpp"

#endif /* GUI_WNDEXPORT_H_ */
