/*
 * SPDX-FileCopyrightText: 2022 Institute Rhea <eduard.filipas@rhea.si>
 *
 * SPDX-License-Identifier: EUPL-1.2
 */

#include "WndExportTD.h"
#include <iostream>

WndExportTD::WndExportTD() : WndExport<TemplateData>() {
	// TODO Auto-generated constructor stub

}

WndExportTD::~WndExportTD() {
	// TODO Auto-generated destructor stub
}

void WndExportTD::fill (TemplateData* myPo, rhea::ListedMap<std::string, TemplateData*>* myMap ) {
	map = myMap;
	fieldGrid->connectWidget(&WndExport::getListing, this);
	std::vector<std::string> hdrs = {};
	hdrs.push_back(lang->getText("txtExport_selected"));
	for (Column* col: myPo->myTemplate->columns){
		hdrs.push_back(col->label);
	}
	fieldGrid->setHeaders(&hdrs,0);
	fieldGrid->setRows(map->size());
	fieldGrid->refresh();
}

Gtk::Widget* WndExportTD::getListing(int col,int row) {

	if (col == 0) {
    	Gtk::CheckButton* chk = new Gtk::CheckButton();
    	chk->set_active(true);
    	return chk;

	}

	Gtk::TextView* tv = new Gtk::TextView();
    tv->set_size_request(100, 35);
    tv->show();
    tv->set_editable(false);
    tv->get_buffer()->set_text(map->getValueAt(row)->values.at(col-1)->getValue());
    return tv;

}

void WndExportTD::onExportClick() {
	std::string content ="";
	lblMessage->set_text("");
	for(int row = 0; row < fieldGrid->getRows(); row++){
		bool zapisi = false;
		for (int col = 0; col < fieldGrid->getColumns(); col++) {

			if (!fieldGrid->getWidget(col,row)){
				continue;
			}

			if (col == 0){
				Gtk::CheckButton* chk = dynamic_cast <Gtk::CheckButton*>(fieldGrid->getWidget(col,row));
				zapisi = chk->get_active();
				continue;
			}

			if (zapisi) {
				Gtk::TextView* tv = dynamic_cast <Gtk::TextView*>(fieldGrid->getWidget(col,row));
				content += tv->get_buffer()->get_text();
				if (col < fieldGrid->getColumns()-1){
					content += ",";
				}
			}
		}
		content += "\r\n";
	}

	unsigned char * data = (unsigned char *)malloc(sizeof(unsigned char)*content.size());
	std::copy(content.begin(), content.begin() + content.length(), data);
	size_t size = content.size();

	file->writeFile(NULL,data,size,false);
	free(data);
	lblMessage->set_text(lang->getText("txtExport_success"));
}
