/*
 * SPDX-FileCopyrightText: 2022 Institute Rhea <eduard.filipas@rhea.si>
 *
 * SPDX-License-Identifier: EUPL-1.2
 */

#include "WndImportTD.h"

WndImportTD::WndImportTD() {
	// TODO Auto-generated constructor stub

}

WndImportTD::~WndImportTD() {
	// TODO Auto-generated destructor stub
}

void WndImportTD::fill(TemplateData* myPo, rhea::ListedMap<std::string, TemplateData*>* myMap, FrameBase<TemplateData>* gui) {
	originGui = gui;
	map = myMap;
	fields = myPo;
	header.clear();
	objectList->clear();


	auto rowObject = *objectList->append();
	rowObject[stringColumns.col_id] = 0;
	rowObject[stringColumns.col_name] = "None";

	for (int i = 0; i < fields->myTemplate->columns.size(); i++) {
	    rowObject = *objectList->append();
	    rowObject[stringColumns.col_id] = fields->myTemplate->columns.at(i)->getPojoId();
	    rowObject[stringColumns.col_name] = fields->myTemplate->columns.at(i)->label;
	}


}
std::string WndImportTD::getListing(int col,int row) {
	return myData.getValueAt(row).at(col);
}

void WndImportTD::onImportClick () {

	for(int i = 0; i < fieldGrid->getRows(); i++) {
		TemplateData* td = new TemplateData();
	    td->setPojoId(originGui->setId());
	    td->setPojoVersion(1);
	    td->setValid(true);
	    td->myTemplate = fields->myTemplate;

		for (int j=0; j < fieldGrid->getColumns();j++) {
			rhea::ComboBox<StringColumns>* cmb= dynamic_cast<rhea::ComboBox<StringColumns>*>(fieldGrid->getHeader(j)->getWidget());
			if (!cmb){
				continue;
			}
			if (cmb->get_active() == cmb->refTreeModel->children().begin()) {
				continue;
			}

			auto iter = cmb->get_active();
			Gtk::TreeRow choice = *iter;
			long col = choice[cmb->columns.col_id];
			long myRowID = 0;
			long myPojoID =  0;
			for (int k = 0 ;k < fields->myTemplate->columns.size(); k++){
				if(col == fields->myTemplate->columns.at(k)->getPojoId()){
					myPojoID = fields->myTemplate->columns.at(k)->getPojoId();
					break;
				}
			}
			std::cout << myPojoID << std::endl;
			TemplateValues* tval = new TemplateValues();
	    	tval->setPojoId(myPojoID);
	    	tval->setPojoVersion(1);
	    	tval->setValue(myData.getValueAt(i).at(j));
	    	tval->setValid(true);
	    	tval->setColumnId(myPojoID);
	    	td->values.push_back(tval);

		}

		td->files.clear();
		for (TemplateFile* tf : fields->myTemplate->templateFiles) {
			TemplateDataFile* tdf = new TemplateDataFile();
		    tdf->setPojoId(tf->getPojoId());
			tdf->setPojoVersion(td->getPojoVersion());
		    tdf->setTemplateFileRowId(tf->getRowId());
		    tdf->setTemplateRowId(tf->getTemplateRowId());
		    tdf->setPath(fields->myTemplate->getName(),true);
		    tdf->setName(std::to_string(td->getPojoId()) + "_" + std::to_string(td->getPojoVersion()) +"_"+ tf->getName());
	//	    std::cout << "našel template datoteke in naredim novo: " << tdf->getFullName() << std::endl;
			td->files.push_back(tdf);
		}


		map->add({std::to_string(td->getPojoId()),td});
		insertData(td);
		originGui->populateTemplateFiles(td);
	}
	originGui->listingGrid->setRows(map->size());
	originGui->listingGrid->refresh();
}

void WndImportTD::insertData (TemplateData* td) {

	rhea::DbParameters params = rhea::DbParameters();
	params.add(td->getPojoId());
	params.add(td->getPojoVersion());
    params.add(td->myTemplate->getRowId());
	params.add(td->isValid() ? 1 : 0 );
	params.add(td->validTill->getAsISO8601());

	rhea::DbResultSet* res =  dbConn->execQuery("Insert into TemplateData("
	    " dataId,"
	    " version,"
	    " templRowId,"
	    " valid,"
	    " validTill ) VALUES (?,?,?,?,?) RETURNING rowId;",params.get());

	if (res->rowCount()>0){
		int i = 0;
		td->setRowId(res->getField("rowId")->getAsLong());
		for (TemplateValues* tv : td->values ) {
			rhea::DbParameters parVal = rhea::DbParameters();
			parVal.add(tv->getPojoId());
			parVal.add(td->getRowId());
			parVal.add(tv->getPojoVersion());
			parVal.add(td->myTemplate->columns.at(i)->getRowId());
			parVal.add(tv->getValue());
			parVal.add(tv->isValid() ? 1 : 0 );
			parVal.add(tv->validTill->getAsISO8601());

			rhea::DbResultSet* resVal = dbConn->execQuery("Insert into TemplateValues ("
    	    		" valueId,"
    		        " dataRowId,"
    		        " version,"
    		        " columnRowId,"
    		        " value,"
    	    	    " valid,"
    	    	    " validTill ) VALUES (?,?,?,?,?,?,?) RETURNING rowId;",parVal.get());
			i++;

		}

		for(TemplateDataFile* tdf : td->files){
			rhea::DbParameters parFile = rhea::DbParameters();
			parFile.add(tdf->getPojoId());
			parFile.add(td->getRowId());
			parFile.add(tdf->getPojoVersion());
			parFile.add((long long) tdf->getTemplateFileRowId());
			parFile.add((long long) tdf->getTemplateRowId());
			parFile.add(tdf->getUUID());
			parFile.add(tdf->getName());
			parFile.add(tdf->getPath());
			parFile.add(tdf->isValid() ? 1 : 0 );
			parFile.add("");

			rhea::DbResultSet* resFile =  dbConn->execQuery("Insert into TemplateDataFiles ("
    	    		" fileId,"
    		        " dataRowId,"
    		        " version,"
					" templFileRowId,"
					" templRowId,"
					" uuid,"
    		        " name,"
					" path,"
    	    	    " valid,"
    	    	    " validTill ) VALUES (?,?,?,?,?,?,?,?,?,?) RETURNING rowId;",parFile.get());
			if (resFile->rowCount()>0){
//				std::cout << "uspešno shranil ime datoteke v bazo" << std::endl;
				tdf->setRowId(resFile->getField("rowId")->getAsLong());
			}
		}
	}

}
