/*
 * SPDX-FileCopyrightText: 2022 Institute Rhea <eduard.filipas@rhea.si>
 *
 * SPDX-License-Identifier: EUPL-1.2
 */

#ifndef MAIN_GRUNFAPP_H
#define MAIN_GRUNFAPP_H

#include "gtkmm.h"
#include "rhea/Menu/Menu.h"
#include "../main/Global.h"
#include "../main/LanguagePack.h"

class GrunfApp : public Gtk::Application {

private:
    Glib::RefPtr<Gtk::Builder> m_refBuilder;
    Glib::ustring strAppMenuBar = "";
    void create_window();
    void on_window_hide(Gtk::Window* window);
    void on_menu_file_quit();
    Global* global = Global::getInstance();
    LanguagePack* lang = LanguagePack::getInstance();

protected:
    GrunfApp();
    virtual ~GrunfApp();
    void on_startup() override;
    void on_activate() override;

public:
    static Glib::RefPtr<GrunfApp> create();
    rhea::Menu* appMenu = new rhea::Menu();

};

#endif //MAIN_GRUNFAPP_H
