/*
 * SPDX-FileCopyrightText: 2022 Institute Rhea <eduard.filipas@rhea.si>
 *
 * SPDX-License-Identifier: EUPL-1.2
 */

#include "iostream"
#include "LanguagePack.h"

LanguagePack::LanguagePack() {

}
LanguagePack* LanguagePack::instance = 0;

LanguagePack* LanguagePack::getInstance() {
    if (!instance) {
        instance = new LanguagePack;
        instance->setDict();
    }
   return instance;
}

void LanguagePack::setDict(){
    std::map<Languages,std::string> text= {};
//------------------------Main menu bar----------------------------

    text.insert_or_assign(Languages::si, "Datoteka");
    text.insert_or_assign(Languages::hr, "Datoteka");
    text.insert_or_assign(Languages::bih,"Datoteka");
    text.insert_or_assign(Languages::en, "File");
    text.insert_or_assign(Languages::de, "File");
    text.insert_or_assign(Languages::fr, "File");
    text.insert_or_assign(Languages::it, "File");
    transText.insert_or_assign("txtMainMenu_FileMenu",text);

    text = {};
    text.insert_or_assign(Languages::si, "Podatki");
    text.insert_or_assign(Languages::hr, "Podaci");
    text.insert_or_assign(Languages::bih,"Podaci");
    text.insert_or_assign(Languages::en, "Data");
    text.insert_or_assign(Languages::de, "Data");
    text.insert_or_assign(Languages::fr, "Data");
    text.insert_or_assign(Languages::it, "Data");
    transText.insert_or_assign("txtMainMenu_WorkMenu",text);



    text = {};
    text.insert_or_assign(Languages::si, "Pomoč");
    text.insert_or_assign(Languages::hr, "Pomoč");
    text.insert_or_assign(Languages::bih,"Pomoč");
    text.insert_or_assign(Languages::en, "Help");
    text.insert_or_assign(Languages::de, "Help");
    text.insert_or_assign(Languages::fr, "Help");
    text.insert_or_assign(Languages::it, "Help");
    transText.insert_or_assign("txtMainMenu_HelpMenu",text);

    text = {};
    text.insert_or_assign(Languages::si, "Strukture");
    text.insert_or_assign(Languages::hr, "Strukture");
    text.insert_or_assign(Languages::bih,"Strukture");
    text.insert_or_assign(Languages::en, "Structures");
    text.insert_or_assign(Languages::de, "Structures");
    text.insert_or_assign(Languages::fr, "Structures");
    text.insert_or_assign(Languages::it, "Structures");
    transText.insert_or_assign("txtMainMenu_FileStructures",text);

    text = {};
    text.insert_or_assign(Languages::si, "Nastavitve");
    text.insert_or_assign(Languages::hr, "Postavke");
    text.insert_or_assign(Languages::bih,"Postavke");
    text.insert_or_assign(Languages::en, "Settings");
    text.insert_or_assign(Languages::de, "Settings");
    text.insert_or_assign(Languages::fr, "Settings");
    text.insert_or_assign(Languages::it, "Settings");
    transText.insert_or_assign("txtMainMenu_FileSettings",text);

    text = {};
    text.insert_or_assign(Languages::si, "Izhod");
    text.insert_or_assign(Languages::hr, "Završi");
    text.insert_or_assign(Languages::bih,"Završi");
    text.insert_or_assign(Languages::en, "Exit");
    text.insert_or_assign(Languages::de, "Exit");
    text.insert_or_assign(Languages::fr, "Exit");
    text.insert_or_assign(Languages::it, "Exit");
    transText.insert_or_assign("txtMainMenu_FileQuit",text);

    text = {};
    text.insert_or_assign(Languages::si, "Navodila");
    text.insert_or_assign(Languages::hr, "Pomoč");
    text.insert_or_assign(Languages::bih,"Pomoč");
    text.insert_or_assign(Languages::en, "Instructions");
    text.insert_or_assign(Languages::de, "Instructions");
    text.insert_or_assign(Languages::fr, "Instructions");
    text.insert_or_assign(Languages::it, "Instructions");
    transText.insert_or_assign("txtMainMenu_HelpInstr",text);

    text = {};
    text.insert_or_assign(Languages::si, "O programu");
    text.insert_or_assign(Languages::hr, "O programu");
    text.insert_or_assign(Languages::bih,"O programu");
    text.insert_or_assign(Languages::en, "About");
    text.insert_or_assign(Languages::de, "About");
    text.insert_or_assign(Languages::fr, "About");
    text.insert_or_assign(Languages::it, "About");
    transText.insert_or_assign("txtMainMenu_HelpAbout",text);

//------------------------fileBox----------------------------------
    text = {};
    text.insert_or_assign(Languages::si, "Datoteke");
    text.insert_or_assign(Languages::hr, "Fajlovi");
    text.insert_or_assign(Languages::bih,"Fajlovi");
    text.insert_or_assign(Languages::en, "Files");
    text.insert_or_assign(Languages::de, "Files");
    text.insert_or_assign(Languages::fr, "Files");
    text.insert_or_assign(Languages::it, "Files");
    transText.insert_or_assign("txtfileBox_Files_RHEA",text);

    text = {};
    text.insert_or_assign(Languages::si, "Dodaj");
    text.insert_or_assign(Languages::hr, "Dodaj");
    text.insert_or_assign(Languages::bih,"Dodaj");
    text.insert_or_assign(Languages::en, "Add");
    text.insert_or_assign(Languages::de, "Add");
    text.insert_or_assign(Languages::fr, "Add");
    text.insert_or_assign(Languages::it, "Add");
    transText.insert_or_assign("txtfileBox_Add_RHEA",text);


//------------------------Editor-----------------------------------
    text = {};
    text.insert_or_assign(Languages::si, "Verzija");
    text.insert_or_assign(Languages::hr, "Verzija");
    text.insert_or_assign(Languages::bih,"Verzija");
    text.insert_or_assign(Languages::en, "Version");
    text.insert_or_assign(Languages::de, "Version");
    text.insert_or_assign(Languages::fr, "Version");
    text.insert_or_assign(Languages::it, "Version");
    transText.insert_or_assign("lblVersion_RHEA",text);

    text = {};
    text.insert_or_assign(Languages::si,"<");
    text.insert_or_assign(Languages::hr,"<");
    text.insert_or_assign(Languages::en,"<");
    text.insert_or_assign(Languages::de,"<");
    text.insert_or_assign(Languages::fr,"<");
    text.insert_or_assign(Languages::it,"<");
    transText.insert_or_assign("txtPrevVer_RHEA",text);

    text = {};
    text.insert_or_assign(Languages::si,">");
    text.insert_or_assign(Languages::hr,">");
    text.insert_or_assign(Languages::en,">");
    text.insert_or_assign(Languages::de,">");
    text.insert_or_assign(Languages::fr,">");
    text.insert_or_assign(Languages::it,">");
    transText.insert_or_assign("txtNextVer_RHEA",text);

    text = {};
    text.insert_or_assign(Languages::si, "Opomba");
    text.insert_or_assign(Languages::hr, "Komentar");
    text.insert_or_assign(Languages::bih,"Komentar");
    text.insert_or_assign(Languages::en, "Comment");
    text.insert_or_assign(Languages::de, "Comment");
    text.insert_or_assign(Languages::fr, "Comment");
    text.insert_or_assign(Languages::it, "Comment");
    transText.insert_or_assign("lblComment_RHEA",text);

    text = {};
    text.insert_or_assign(Languages::si, "Novi");
    text.insert_or_assign(Languages::hr, "Novi");
    text.insert_or_assign(Languages::bih,"Novi");
    text.insert_or_assign(Languages::en, "New");
    text.insert_or_assign(Languages::de, "New");
    text.insert_or_assign(Languages::fr, "New");
    text.insert_or_assign(Languages::it, "New");
    transText.insert_or_assign("txtEditorNew_RHEA",text);

    text = {};
    text.insert_or_assign(Languages::si, "Shrani");
    text.insert_or_assign(Languages::hr, "Sačuvaj");
    text.insert_or_assign(Languages::bih,"Sačuvaj");
    text.insert_or_assign(Languages::en, "Save");
    text.insert_or_assign(Languages::de, "Save");
    text.insert_or_assign(Languages::fr, "Save");
    text.insert_or_assign(Languages::it, "Save");
    transText.insert_or_assign("txtEditorSave_RHEA",text);

    text = {};
    text.insert_or_assign(Languages::si, "Izbriši");
    text.insert_or_assign(Languages::hr, "Briši");
    text.insert_or_assign(Languages::bih,"Briši");
    text.insert_or_assign(Languages::en, "Delete");
    text.insert_or_assign(Languages::de, "Delete");
    text.insert_or_assign(Languages::fr, "Delete");
    text.insert_or_assign(Languages::it, "Delete");
    transText.insert_or_assign("txtEditorDelete_RHEA",text);

    text = {};
    text.insert_or_assign(Languages::si, "Uvozi");
    text.insert_or_assign(Languages::hr, "Uvozi");
    text.insert_or_assign(Languages::bih,"Uvozi");
    text.insert_or_assign(Languages::en, "Import");
    text.insert_or_assign(Languages::de, "Import");
    text.insert_or_assign(Languages::fr, "Import");
    text.insert_or_assign(Languages::it, "Import");
    transText.insert_or_assign("txtEditorImport_RHEA",text);

    text = {};
    text.insert_or_assign(Languages::si, "Izvozi");
    text.insert_or_assign(Languages::hr, "Izvozi");
    text.insert_or_assign(Languages::bih,"Izvozi");
    text.insert_or_assign(Languages::en, "Export");
    text.insert_or_assign(Languages::de, "Export");
    text.insert_or_assign(Languages::fr, "Export");
    text.insert_or_assign(Languages::it, "Export");
    transText.insert_or_assign("txtEditorExport_RHEA",text);

    text = {};
    text.insert_or_assign(Languages::si, "Izberite jezik:");
    text.insert_or_assign(Languages::hr, "Izaberite jezik:");
    text.insert_or_assign(Languages::bih,"Izaberite jezik:");
    text.insert_or_assign(Languages::en, "Select language:");
    text.insert_or_assign(Languages::de, "Select language:");
    text.insert_or_assign(Languages::fr, "Select language:");
    text.insert_or_assign(Languages::it, "Select language:");
    transText.insert_or_assign("txtSettingsLabelLang",text);

//--------------FrmTemplDef---------------------------------

    text = {};
    text.insert_or_assign(Languages::si, "Izbrana struktura je ");
    text.insert_or_assign(Languages::hr, "Izabrana struktura je ");
    text.insert_or_assign(Languages::bih,"Izabrana struktura je ");
    text.insert_or_assign(Languages::en, "You selected structure ");
    text.insert_or_assign(Languages::de, "You selected structure ");
    text.insert_or_assign(Languages::fr, "You selected structure ");
    text.insert_or_assign(Languages::it, "You selected structure ");
    transText.insert_or_assign("txtTemplDef_lblForTemplate",text);

    text = {};
    text.insert_or_assign(Languages::si, "Prosim izberite strukturu");
    text.insert_or_assign(Languages::hr, "Molim izaberite strukturu");
    text.insert_or_assign(Languages::bih,"Molim izaberite strukturu");
    text.insert_or_assign(Languages::en, "Please select structure");
    text.insert_or_assign(Languages::de, "Please select structure");
    text.insert_or_assign(Languages::fr, "Please select structure");
    text.insert_or_assign(Languages::it, "Please select structure");
    transText.insert_or_assign("txtTemplDef_lblForTemplateDefault",text);

    text = {};
    text.insert_or_assign(Languages::si, "Dodaj strukturo");
    text.insert_or_assign(Languages::hr, "Dodaj strukturu");
    text.insert_or_assign(Languages::bih,"Dodaj strukturu");
    text.insert_or_assign(Languages::en, "Add structure");
    text.insert_or_assign(Languages::de, "Add structure");
    text.insert_or_assign(Languages::fr, "Add structure");
    text.insert_or_assign(Languages::it, "Add structure");
    transText.insert_or_assign("txtTemplDef_btnAddTemplate",text);

    text = {};
    text.insert_or_assign(Languages::si, "Dodaj atribut");
    text.insert_or_assign(Languages::hr, "Dodaj atribut");
    text.insert_or_assign(Languages::bih,"Dodaj atribut");
    text.insert_or_assign(Languages::en, "Add atribute");
    text.insert_or_assign(Languages::de, "Add atribute");
    text.insert_or_assign(Languages::fr, "Add atribute");
    text.insert_or_assign(Languages::it, "Add atribute");
    transText.insert_or_assign("txtTemplDef_btnAddColumn",text);

    text = {};
    text.insert_or_assign(Languages::si, "Shrani atribute");
    text.insert_or_assign(Languages::hr, "Sačuvaj atribute");
    text.insert_or_assign(Languages::bih,"Sačuvaj atribute");
    text.insert_or_assign(Languages::en, "Save atributes");
    text.insert_or_assign(Languages::de, "Save atributes");
    text.insert_or_assign(Languages::fr, "Save atributes");
    text.insert_or_assign(Languages::it, "Save atributes");
    transText.insert_or_assign("txtTemplDef_btnSaveColumns",text);

    text = {};
    text.insert_or_assign(Languages::si, "Podrobnosti");
    text.insert_or_assign(Languages::hr, "Postavke");
    text.insert_or_assign(Languages::bih,"Postavke");
    text.insert_or_assign(Languages::en, "Details");
    text.insert_or_assign(Languages::de, "Details");
    text.insert_or_assign(Languages::fr, "Details");
    text.insert_or_assign(Languages::it, "Details");
    transText.insert_or_assign("txtTemplDef_btnDetails",text);

    text = {};
    text.insert_or_assign(Languages::si, "Nazaj");
    text.insert_or_assign(Languages::hr, "Nazad");
    text.insert_or_assign(Languages::bih,"Nazad");
    text.insert_or_assign(Languages::en, "Back");
    text.insert_or_assign(Languages::de, "Back");
    text.insert_or_assign(Languages::fr, "Back");
    text.insert_or_assign(Languages::it, "Back");
    transText.insert_or_assign("txtTemplDef_btnBack",text);

    text = {};
    text.insert_or_assign(Languages::si, "Odstrani");
    text.insert_or_assign(Languages::hr, "Izbriši");
    text.insert_or_assign(Languages::bih,"Izbriši");
    text.insert_or_assign(Languages::en, "Delete");
    text.insert_or_assign(Languages::de, "Delete");
    text.insert_or_assign(Languages::fr, "Delete");
    text.insert_or_assign(Languages::it, "Delete");
    transText.insert_or_assign("txtTemplDef_btnDelete",text);

    text = {};
    text.insert_or_assign(Languages::si, "Shrani");
    text.insert_or_assign(Languages::hr, "Sačuvaj");
    text.insert_or_assign(Languages::bih,"Sačuvaj");
    text.insert_or_assign(Languages::en, "Save");
    text.insert_or_assign(Languages::de, "Save");
    text.insert_or_assign(Languages::fr, "Save");
    text.insert_or_assign(Languages::it, "Save");
    transText.insert_or_assign("txtTemplDef_btnSave",text);

    text = {};
    text.insert_or_assign(Languages::si, "Id");
    text.insert_or_assign(Languages::hr, "Id");
    text.insert_or_assign(Languages::bih,"Id");
    text.insert_or_assign(Languages::en, "Id");
    text.insert_or_assign(Languages::de, "Id");
    text.insert_or_assign(Languages::fr, "Id");
    text.insert_or_assign(Languages::it, "Id");
    transText.insert_or_assign("txtTemplDef_hdrsListCol1",text);

    text = {};
    text.insert_or_assign(Languages::si, "Ime");
    text.insert_or_assign(Languages::hr, "Naziv");
    text.insert_or_assign(Languages::bih,"Naziv");
    text.insert_or_assign(Languages::en, "Name");
    text.insert_or_assign(Languages::de, "Name");
    text.insert_or_assign(Languages::fr, "Name");
    text.insert_or_assign(Languages::it, "Name");
    transText.insert_or_assign("txtTemplDef_hdrsListCol2",text);

     text = {};
     text.insert_or_assign(Languages::si, "Bližnjica");
     text.insert_or_assign(Languages::hr, "Prečica");
     text.insert_or_assign(Languages::bih,"Prečica");
     text.insert_or_assign(Languages::en, "Shortcut");
     text.insert_or_assign(Languages::de, "Shortcut");
     text.insert_or_assign(Languages::fr, "Shortcut");
     text.insert_or_assign(Languages::it, "Shortcut");
     transText.insert_or_assign("txtTemplDef_hdrsListCol3",text);

     text = {};
     text.insert_or_assign(Languages::si, "Vidno v meniju");
     text.insert_or_assign(Languages::hr, "Pokaži u meniju");
     text.insert_or_assign(Languages::bih,"Pokaži u meniju");
     text.insert_or_assign(Languages::en, "Show in menu");
     text.insert_or_assign(Languages::de, "Show in menu");
     text.insert_or_assign(Languages::fr, "Show in menu");
     text.insert_or_assign(Languages::it, "Show in menu");
     transText.insert_or_assign("txtTemplDef_hdrsListCol4",text);

     text = {};
     text.insert_or_assign(Languages::si, "Ime atributa");
     text.insert_or_assign(Languages::hr, "Ime atributa");
     text.insert_or_assign(Languages::bih,"Ime atributa");
     text.insert_or_assign(Languages::en, "Atribute name");
     text.insert_or_assign(Languages::de, "Atribute name");
     text.insert_or_assign(Languages::fr, "Atribute name");
     text.insert_or_assign(Languages::it, "Atribute name");
     transText.insert_or_assign("txtTemplDef_hdrsDefCol0",text);

     text = {};
     text.insert_or_assign(Languages::si, "Libre koda");
     text.insert_or_assign(Languages::hr, "Libre koda");
     text.insert_or_assign(Languages::bih,"Libre koda");
     text.insert_or_assign(Languages::en, "Libre code");
     text.insert_or_assign(Languages::de, "Libre code");
     text.insert_or_assign(Languages::fr, "Libre code");
     text.insert_or_assign(Languages::it, "Libre code");
     transText.insert_or_assign("txtTemplDef_hdrsDefCol1",text);

     text = {};
     text.insert_or_assign(Languages::si, "Vrst. red");
     text.insert_or_assign(Languages::hr, "Po redu");
     text.insert_or_assign(Languages::bih,"Po redu");
     text.insert_or_assign(Languages::en, "Order");
     text.insert_or_assign(Languages::de, "Order");
     text.insert_or_assign(Languages::fr, "Order");
     text.insert_or_assign(Languages::it, "Order");
     transText.insert_or_assign("txtTemplDef_hdrsDefCol2",text);

     text = {};
     text.insert_or_assign(Languages::si, "Tip");
     text.insert_or_assign(Languages::hr, "Tip");
     text.insert_or_assign(Languages::bih,"Tip");
     text.insert_or_assign(Languages::en, "Type");
     text.insert_or_assign(Languages::de, "Type");
     text.insert_or_assign(Languages::fr, "Type");
     text.insert_or_assign(Languages::it, "Type");
     transText.insert_or_assign("txtTemplDef_hdrsDefCol3",text);

     text = {};
     text.insert_or_assign(Languages::si, "Element");
     text.insert_or_assign(Languages::hr, "Element");
     text.insert_or_assign(Languages::bih,"Element");
     text.insert_or_assign(Languages::en, "Element");
     text.insert_or_assign(Languages::de, "Element");
     text.insert_or_assign(Languages::fr, "Element");
     text.insert_or_assign(Languages::it, "Element");
     transText.insert_or_assign("txtTemplDef_hdrsDefCol4",text);

     text = {};
     text.insert_or_assign(Languages::si, "Možnosti");
     text.insert_or_assign(Languages::hr, "Mogučnosti");
     text.insert_or_assign(Languages::bih,"Mogučnosti");
     text.insert_or_assign(Languages::en, "Options");
     text.insert_or_assign(Languages::de, "Options");
     text.insert_or_assign(Languages::fr, "Options");
     text.insert_or_assign(Languages::it, "Options");
     transText.insert_or_assign("txtTemplDef_hdrsDefCol5",text);

     text = {};
     text.insert_or_assign(Languages::si, "Tekst");
     text.insert_or_assign(Languages::hr, "Tekst");
     text.insert_or_assign(Languages::bih,"Tekst");
     text.insert_or_assign(Languages::en, "Text");
     text.insert_or_assign(Languages::de, "Text");
     text.insert_or_assign(Languages::fr, "Text");
     text.insert_or_assign(Languages::it, "Text");
     transText.insert_or_assign("txtTemplDef_objectList1",text);

     text = {};
     text.insert_or_assign(Languages::si, "Check Box");
     text.insert_or_assign(Languages::hr, "Check Box");
     text.insert_or_assign(Languages::bih,"Check Box");
     text.insert_or_assign(Languages::en, "Check Box");
     text.insert_or_assign(Languages::de, "Check Box");
     text.insert_or_assign(Languages::fr, "Check Box");
     text.insert_or_assign(Languages::it, "Check Box");
     transText.insert_or_assign("txtTemplDef_objectList2",text);

     text = {};
     text.insert_or_assign(Languages::si, "Spustni seznam");
     text.insert_or_assign(Languages::hr, "Combo box");
     text.insert_or_assign(Languages::bih,"Combo box");
     text.insert_or_assign(Languages::en, "Combo box");
     text.insert_or_assign(Languages::de, "Combo box");
     text.insert_or_assign(Languages::fr, "Combo box");
     text.insert_or_assign(Languages::it, "Combo box");
     transText.insert_or_assign("txtTemplDef_objectList3",text);

     text = {};
     text.insert_or_assign(Languages::si, "Options");
     text.insert_or_assign(Languages::hr, "Options");
     text.insert_or_assign(Languages::bih,"Options");
     text.insert_or_assign(Languages::en, "Options");
     text.insert_or_assign(Languages::de, "Options");
     text.insert_or_assign(Languages::fr, "Options");
     text.insert_or_assign(Languages::it, "Options");
     transText.insert_or_assign("txtTemplDef_objectList4",text);

     text = {};
     text.insert_or_assign(Languages::si, "Koledar");
     text.insert_or_assign(Languages::hr, "Kalendar");
     text.insert_or_assign(Languages::bih,"Kalendar");
     text.insert_or_assign(Languages::en, "Calendar");
     text.insert_or_assign(Languages::de, "Calendar");
     text.insert_or_assign(Languages::fr, "Calendar");
     text.insert_or_assign(Languages::it, "Calendar");
     transText.insert_or_assign("txtTemplDef_objectList5",text);

     text = {};
     text.insert_or_assign(Languages::si, "Preglednica");
     text.insert_or_assign(Languages::hr, "Tabela");
     text.insert_or_assign(Languages::bih,"Tabela");
     text.insert_or_assign(Languages::en, "Table");
     text.insert_or_assign(Languages::de, "Table");
     text.insert_or_assign(Languages::fr, "Table");
     text.insert_or_assign(Languages::it, "Table");
     transText.insert_or_assign("txtTemplDef_objectList6",text);

     text = {};
     text.insert_or_assign(Languages::si, "Tekst");
     text.insert_or_assign(Languages::hr, "Tekst");
     text.insert_or_assign(Languages::bih,"Tekst");
     text.insert_or_assign(Languages::en, "Text");
     text.insert_or_assign(Languages::de, "Text");
     text.insert_or_assign(Languages::fr, "Text");
     text.insert_or_assign(Languages::it, "Text");
     transText.insert_or_assign("txtTemplDef_typeList1",text);

     text = {};
     text.insert_or_assign(Languages::si, "Datum");
     text.insert_or_assign(Languages::hr, "Datum");
     text.insert_or_assign(Languages::bih,"Datum");
     text.insert_or_assign(Languages::en, "Date");
     text.insert_or_assign(Languages::de, "Date");
     text.insert_or_assign(Languages::fr, "Date");
     text.insert_or_assign(Languages::it, "Date");
     transText.insert_or_assign("txtTemplDef_typeList2",text);

     text = {};
     text.insert_or_assign(Languages::si, "Decimal");
     text.insert_or_assign(Languages::hr, "Decimal");
     text.insert_or_assign(Languages::bih,"Decimal");
     text.insert_or_assign(Languages::en, "Decimal");
     text.insert_or_assign(Languages::de, "Decimal");
     text.insert_or_assign(Languages::fr, "Decimal");
     text.insert_or_assign(Languages::it, "Decimal");
     transText.insert_or_assign("txtTemplDef_typeList3",text);

     text = {};
     text.insert_or_assign(Languages::si, "Celo število");
     text.insert_or_assign(Languages::hr, "Cjeli broj");
     text.insert_or_assign(Languages::bih,"Cjeli broj");
     text.insert_or_assign(Languages::en, "Integer");
     text.insert_or_assign(Languages::de, "Integer");
     text.insert_or_assign(Languages::fr, "Integer");
     text.insert_or_assign(Languages::it, "Integer");
     transText.insert_or_assign("txtTemplDef_typeList4",text);

     text = {};
     text.insert_or_assign(Languages::si, "Števec");
     text.insert_or_assign(Languages::hr, "Brojilo");
     text.insert_or_assign(Languages::bih,"Brojilo");
     text.insert_or_assign(Languages::en, "Index");
     text.insert_or_assign(Languages::de, "Index");
     text.insert_or_assign(Languages::fr, "Index");
     text.insert_or_assign(Languages::it, "Index");
     transText.insert_or_assign("txtTemplDef_typeList5",text);

//-----------------------------------FrmAbout-------------------------
     text = {};
     text.insert_or_assign(Languages::si, "Različica");
     text.insert_or_assign(Languages::hr, "Verzija");
     text.insert_or_assign(Languages::bih,"Verzija");
     text.insert_or_assign(Languages::en, "Version");
     text.insert_or_assign(Languages::de, "Version");
     text.insert_or_assign(Languages::fr, "Version");
     text.insert_or_assign(Languages::it, "Version");
     transText.insert_or_assign("txtFrmAbout_Version",text);

     text = {};
     text.insert_or_assign(Languages::si, "Program grunf razvija Eduard Filipas v imenu Zavod Rhea");
     text.insert_or_assign(Languages::hr, "Program grunf razvija Eduard Filipas za Zavod Rhea");
     text.insert_or_assign(Languages::bih,"Program grunf razvija Eduard Filipas za Zavod Rhea");
     text.insert_or_assign(Languages::en, "Writen by Eduard Filipas for Institute Rhea");
     text.insert_or_assign(Languages::de, "Writen by Eduard Filipas for Institute Rhea");
     text.insert_or_assign(Languages::fr, "Writen by Eduard Filipas for Institute Rhea");
     text.insert_or_assign(Languages::it, "Writen by Eduard Filipas for Institute Rhea");
     transText.insert_or_assign("txtFrmAbout_Author",text);

     text = {};
     text.insert_or_assign(Languages::si, "\nGrunf je objavljen pod licenco EUPL. Grunf je prosto-dostopen in odprto-koden program,\n"
    		 	 	 	 	 	 	 	  "katerega lahko prosto širite in spreminjate izvorno kodo pod licenco EUPL. Več o licenci EUPL\n"
    		 	 	 	 	 	 	 	  "si lahko preberete na https://eupl.eu/1.2/sl/.\n\n"
    		                              "Program grunf je brez kakršnih koli zagotovil ali garancije, da deluje brezhibno.\n"
    		 	 	 	 	 	 	 	  "Program uporabljate na lastno odgovornost.Avtor ne odgovarja za kakršno koli\n"
    		                              "škodo, ki bi jo aplikacija lahko povzročila, četudi bi bil avtor s tem seznanjen.");
     text.insert_or_assign(Languages::hr, "\nGrunf je izdan sa licencom EUPL. Grunf je prosto-dostupan program\n"
    		 	 	 	 	 	 	 	  "kojeg možete širiti i prilagodjivati izvorni kod pod licencom EUPL.\n"
    		 	 	 	 	 	 	 	  "Više o licenciji možete pročitati na https://eupl.eu/1.2/hr/\n\n"
    		 	 	 	 	 	 	 	  "Program grunf je bez ikakvog jamstva ili garancije. Program \n"
    		 	 	 	 	 	 	 	  "upotrebljavate na svoju odgovornost. Autor nije odgovoran \n"
    		 	 	 	 	 	 	 	  "za bilu kakvu štetu, koju može aplikacija uzrokovati, čak i \n"
    		 	 	 	 	 	 	 	  "ako bi autor bio saznanjen time");
     text.insert_or_assign(Languages::bih,"\nGrunf je izdan sa licencom EUPL. Grunf je prosto-dostupan program\n"
	 	 	 	  	  	  	  	  	  	  "kojeg možete širiti i prilagodjivati izvorni kod pod licencom EUPL.\n"
	 	 	 	  	  	  	  	  	  	  "Više o licenciji možete pročitati na https://eupl.eu/1.2/hr/\n\n"
	 	 	 	  	  	  	  	  	  	  "Program grunf je bez ikakvog jamstva ili garancije. Program \n"
	 	 	 	  	  	  	  	  	  	  "upotrebljavate na svoju odgovornost. Autor nije odgovoran \n"
	 	 	 	  	  	  	  	  	  	  "za bilu kakvu štetu, koju može aplikacija uzrokovati, čak i \n"
	 	 	 	  	  	  	  	  	  	  "ako bi autor bio saznanjen time");
     text.insert_or_assign(Languages::en, "\nGrunf is published under licence EUPl. Grunf is free and open source software, \n"
    		 	 	 	 	 	 	 	  "that can be freely shared or modified under licence EUPL. More about licence EUPL\n"
    		 	 	 	 	 	 	 	  "can be found at https://eupl.eu/1.2/en/.\n\n"
    		 	 	 	 	 	 	 	  "Aplication grunf is without any warranty and is as is.Author will not be and is\n"
    		 	 	 	 	 	 	 	  "not held responsible for any damage coused by use of application grunf, even if \n"
    		 	 	 	 	 	 	 	  "author is aware that such possibility exists");
     text.insert_or_assign(Languages::de, "\nGrunf is published under licence EUPl. Grunf is free and open source software, \n"
	 	 	 	  	  	  	  	  	  	  "that can be freely shared or modified under licence EUPL. More about licence EUPL\n"
    		 	 	 	 	 	 	 	  "can be found at https://eupl.eu/1.2/de/.\n\n"
    		 	 	 	 	 	 	 	  "Aplication grunf is without any warranty and is as is.Author will not be and is\n"
	 	 	 	  	  	  	  	  	  	  "not held responsible for any damage coused by use of application grunf, even if \n"
	 	 	 	  	  	  	  	  	  	  "author is aware that such possibility exists");
     text.insert_or_assign(Languages::fr, "\nGrunf is published under licence EUPl. Grunf is free and open source software, \n"
	 	 	 	  	  	  	  	  	  	  "that can be freely shared or modified under licence EUPL. More about licence EUPL\n"
	 	 	 	  	  	  	  	  	  	  "can be found at https://eupl.eu/1.2/fr/.\n\n"
	 	 	 	  	  	  	  	  	  	  "Aplication grunf is without any warranty and is as is.Author will not be and is\n"
	 	 	 	  	  	  	  	  	  	  "not held responsible for any damage coused by use of application grunf, even if \n"
	 	 	 	  	  	  	  	  	  	  "author is aware that such possibility exists");
     text.insert_or_assign(Languages::it, "\nGrunf is published under licence EUPl. Grunf is free and open source software, \n"
	 	 	 	  	  	  	  	  	  	  "that can be freely shared or modified under licence EUPL. More about licence EUPL\n"
	 	 	 	  	  	  	  	  	  	  "can be found at https://eupl.eu/1.2/it/.\n\n"
	 	 	 	  	  	  	  	  	  	  "Aplication grunf is without any warranty and is as is.Author will not be and is\n"
	 	 	 	  	  	  	  	  	  	  "not held responsible for any damage coused by use of application grunf, even if \n"
	 	 	 	  	  	  	  	  	  	  "author is aware that such possibility exists");
     transText.insert_or_assign("txtFrmAbout_Licence",text);

//-----------------------------DialogOptions----------------
     text = {};
     text.insert_or_assign(Languages::si, "Struktura");
     text.insert_or_assign(Languages::hr, "Struktura");
     text.insert_or_assign(Languages::bih,"Struktura");
     text.insert_or_assign(Languages::en, "Structure");
     text.insert_or_assign(Languages::de, "Structure");
     text.insert_or_assign(Languages::fr, "Structure");
     text.insert_or_assign(Languages::it, "Structure");
     transText.insert_or_assign("txtDialog_Structure",text);

     text = {};
     text.insert_or_assign(Languages::si, "Atribut");
     text.insert_or_assign(Languages::hr, "Atribut");
     text.insert_or_assign(Languages::bih,"Atribut");
     text.insert_or_assign(Languages::en, "Atribut");
     text.insert_or_assign(Languages::de, "Atribut");
     text.insert_or_assign(Languages::fr, "Atribut");
     text.insert_or_assign(Languages::it, "Atribut");
     transText.insert_or_assign("txtDialog_Atribut",text);

     text = {};
     text.insert_or_assign(Languages::si, "Dodaj");
     text.insert_or_assign(Languages::hr, "Dodaj");
     text.insert_or_assign(Languages::bih,"Dodaj");
     text.insert_or_assign(Languages::en, "Add");
     text.insert_or_assign(Languages::de, "Add");
     text.insert_or_assign(Languages::fr, "Add");
     text.insert_or_assign(Languages::it, "Add");
     transText.insert_or_assign("txtDialog_Add",text);

     text = {};
     text.insert_or_assign(Languages::si, "Shrani");
     text.insert_or_assign(Languages::hr, "Sačuvaj");
     text.insert_or_assign(Languages::bih,"Sačuvaj");
     text.insert_or_assign(Languages::en, "Save");
     text.insert_or_assign(Languages::de, "Save");
     text.insert_or_assign(Languages::fr, "Save");
     text.insert_or_assign(Languages::it, "Save");
     transText.insert_or_assign("txtDialog_btnSave",text);

     text = {};
     text.insert_or_assign(Languages::si, "Odstrani");
     text.insert_or_assign(Languages::hr, "Izbriši");
     text.insert_or_assign(Languages::bih,"Izbriši");
     text.insert_or_assign(Languages::en, "Remove");
     text.insert_or_assign(Languages::de, "Remove");
     text.insert_or_assign(Languages::fr, "Remove");
     text.insert_or_assign(Languages::it, "Remove");
     transText.insert_or_assign("txtDialog_btnRemove",text);

     text = {};
     text.insert_or_assign(Languages::si, "Dodaj kolono");
     text.insert_or_assign(Languages::hr, "Dodaj kolonu");
     text.insert_or_assign(Languages::bih,"Dodaj kolonu");
     text.insert_or_assign(Languages::en, "Add column");
     text.insert_or_assign(Languages::de, "Add column");
     text.insert_or_assign(Languages::fr, "Add column");
     text.insert_or_assign(Languages::it, "Add column");
     transText.insert_or_assign("txtDialog_btnAddCol",text);

     text = {};
     text.insert_or_assign(Languages::si, "Prefix");
     text.insert_or_assign(Languages::hr, "Prefix");
     text.insert_or_assign(Languages::bih,"Prefix");
     text.insert_or_assign(Languages::en, "Prefix");
     text.insert_or_assign(Languages::de, "Prefix");
     text.insert_or_assign(Languages::fr, "Prefix");
     text.insert_or_assign(Languages::it, "Prefix");
     transText.insert_or_assign("txtDialog_lblPref",text);

     text = {};
     text.insert_or_assign(Languages::si, "Korak");
     text.insert_or_assign(Languages::hr, "Korak");
     text.insert_or_assign(Languages::bih,"Korak");
     text.insert_or_assign(Languages::en, "Step");
     text.insert_or_assign(Languages::de, "Step");
     text.insert_or_assign(Languages::fr, "Step");
     text.insert_or_assign(Languages::it, "Step");
     transText.insert_or_assign("txtDialog_lblStep",text);

     text = {};
     text.insert_or_assign(Languages::si, "Postfix");
     text.insert_or_assign(Languages::hr, "Postfix");
     text.insert_or_assign(Languages::bih,"Postfix");
     text.insert_or_assign(Languages::en, "Postfix");
     text.insert_or_assign(Languages::de, "Postfix");
     text.insert_or_assign(Languages::fr, "Postfix");
     text.insert_or_assign(Languages::it, "Postfix");
     transText.insert_or_assign("txtDialog_lblPost",text);

//------------------------WndExport-------------------------
     text = {};
     text.insert_or_assign(Languages::si, "Izvozi");
     text.insert_or_assign(Languages::hr, "Izvozi");
     text.insert_or_assign(Languages::bih,"Izvozi");
     text.insert_or_assign(Languages::en, "Export");
     text.insert_or_assign(Languages::de, "Export");
     text.insert_or_assign(Languages::fr, "Export");
     text.insert_or_assign(Languages::it, "Export");
     transText.insert_or_assign("txtExport_btnExport",text);

     text = {};
     text.insert_or_assign(Languages::si, "Shrani kot");
     text.insert_or_assign(Languages::hr, "Sačuvaj kao");
     text.insert_or_assign(Languages::bih,"Sačuvaj kao");
     text.insert_or_assign(Languages::en, "Save as");
     text.insert_or_assign(Languages::de, "Save as");
     text.insert_or_assign(Languages::fr, "Save as");
     text.insert_or_assign(Languages::it, "Save as");
     transText.insert_or_assign("txtExport_btnFile",text);

     text = {};
     text.insert_or_assign(Languages::si, "Izberi datoteko");
     text.insert_or_assign(Languages::hr, "Izaberi fajl");
     text.insert_or_assign(Languages::bih,"Izaberi fajl");
     text.insert_or_assign(Languages::en, "Please select a file");
     text.insert_or_assign(Languages::de, "Please select a file");
     text.insert_or_assign(Languages::fr, "Please select a file");
     text.insert_or_assign(Languages::it, "Please select a file");
     transText.insert_or_assign("txtExport_selectFile",text);

     text = {};
     text.insert_or_assign(Languages::si, "Prekliči");
     text.insert_or_assign(Languages::hr, "Prekini");
     text.insert_or_assign(Languages::bih,"Prekini");
     text.insert_or_assign(Languages::en, "Cancel");
     text.insert_or_assign(Languages::de, "Cancel");
     text.insert_or_assign(Languages::fr, "Cancel");
     text.insert_or_assign(Languages::it, "Cancel");
     transText.insert_or_assign("txtExport_cancel",text);

     text = {};
     text.insert_or_assign(Languages::si, "Shrani");
     text.insert_or_assign(Languages::hr, "Sačuvaj");
     text.insert_or_assign(Languages::bih,"Sačuvaj");
     text.insert_or_assign(Languages::en, "Save");
     text.insert_or_assign(Languages::de, "Save");
     text.insert_or_assign(Languages::fr, "Save");
     text.insert_or_assign(Languages::it, "Save");
     transText.insert_or_assign("txtExport_save",text);

     text = {};
     text.insert_or_assign(Languages::si, "Izbran");
     text.insert_or_assign(Languages::hr, "Izabran");
     text.insert_or_assign(Languages::bih,"Izabran");
     text.insert_or_assign(Languages::en, "Selected");
     text.insert_or_assign(Languages::de, "Selected");
     text.insert_or_assign(Languages::fr, "Selected");
     text.insert_or_assign(Languages::it, "Selected");
     transText.insert_or_assign("txtExport_selected",text);

     text = {};
     text.insert_or_assign(Languages::si, "Izvoz uspešen");
     text.insert_or_assign(Languages::hr, "Izvoz uspješan");
     text.insert_or_assign(Languages::bih,"Izvoz uspješan");
     text.insert_or_assign(Languages::en, "Export is finished");
     text.insert_or_assign(Languages::de, "Export is finished");
     text.insert_or_assign(Languages::fr, "Export is finished");
     text.insert_or_assign(Languages::it, "Export is finished");
     transText.insert_or_assign("txtExport_success",text);

//-------------------WndImport-------------------------------
     text = {};
     text.insert_or_assign(Languages::si, "Datoteka");
     text.insert_or_assign(Languages::hr, "Fajl");
     text.insert_or_assign(Languages::bih,"Fajl");
     text.insert_or_assign(Languages::en, "File");
     text.insert_or_assign(Languages::de, "File");
     text.insert_or_assign(Languages::fr, "File");
     text.insert_or_assign(Languages::it, "File");
     transText.insert_or_assign("txtImport_File",text);

     text = {};
     text.insert_or_assign(Languages::si, "Uvozi");
     text.insert_or_assign(Languages::hr, "Uvoz");
     text.insert_or_assign(Languages::bih,"Uvoz");
     text.insert_or_assign(Languages::en, "Import");
     text.insert_or_assign(Languages::de, "Import");
     text.insert_or_assign(Languages::fr, "Import");
     text.insert_or_assign(Languages::it, "Import");
     transText.insert_or_assign("txtImport_import",text);

     text = {};
     text.insert_or_assign(Languages::si, "Odpri");
     text.insert_or_assign(Languages::hr, "Otvori");
     text.insert_or_assign(Languages::bih,"Otvori");
     text.insert_or_assign(Languages::en, "Open");
     text.insert_or_assign(Languages::de, "Open");
     text.insert_or_assign(Languages::fr, "Open");
     text.insert_or_assign(Languages::it, "Open");
     transText.insert_or_assign("txtImport_Open",text);


}

/*----------------------------------------------------------
  prefix tells if how we manipulate text
  txt = no text postfix
  lbl  = text + ":" postfix
*/

std::string LanguagePack::getText(std::string item, Languages lng){
    bool napaka = {false};

    if (transText.contains(item)) {
        std::map<Languages, std::string> myVal = transText.at(item);
        if (!myVal.empty() && (myVal.contains(lng))) {
            std::string mystring(myVal.at(getLanguage()));
            return item.starts_with("lbl")   ? mystring + ":" : mystring;  //here add other options for text manipulation
        } else {
            napaka = true;
        }
    } else { napaka = true; }
    if (napaka) {
        std::cout << "Manjka prevod za element: " << item << std::endl;
    }
    return "";}

std::string LanguagePack::getText(std::string item){
   return getText(item, getLanguage());
}

Languages LanguagePack::getLanguage() {
    return lang;
}

void LanguagePack::setLanguage(Languages lng) {
    lang= lng;
}
