/*
 * SPDX-FileCopyrightText: 2022 Institute Rhea <eduard.filipas@rhea.si>
 *
 * SPDX-License-Identifier: EUPL-1.2
 */

#ifndef MAIN_LANGUAGEPACK_H
#define MAIN_LANGUAGEPACK_H

#include <map>
#include "string"

enum class Languages {si, hr, bih, en, de, fr, it};

class LanguagePack {
private:
    std::map<std::string, std::map<Languages,std::string>> transText;
    static LanguagePack* instance;
    Languages lang;
    LanguagePack();
    void setDict();

public:
    static LanguagePack* getInstance();
    void setLanguage(Languages lng);
    Languages getLanguage();
    std::string getText(std::string item, Languages lng);
    std::string getText(std::string item);
};

#endif //MAIN_LANGUAGEPACK_H
