/*
 * SPDX-FileCopyrightText: 2022 Institute Rhea <eduard.filipas@rhea.si>
 *
 * SPDX-License-Identifier: EUPL-1.2
 */

#include "UpdateDB.h"

UpdateDB::UpdateDB() {
	// TODO Auto-generated constructor stub

}

UpdateDB::~UpdateDB() {
	// TODO Auto-generated destructor stub
}

void UpdateDB::makeUpdate() {
	DB_VERSION = dbConn->getVersion();
	std::string old_ver = DB_VERSION;
	if ( NEW_VERSION == "1" ) {
		if ( DB_VERSION == "0" ) { upgrade_v1();}

	} else if(NEW_VERSION == "2" ) {
		if ( DB_VERSION == "0" ){ upgrade_v1();}
		if ( DB_VERSION == "1" ){ upgrade_v2();}
	}

	if (old_ver == "0") {
		TestDB* testDb= new TestDB(dbConn->getDB());
		testDb->populateTemplates();
		delete testDb;
	}

}

void UpdateDB::upgrade_v1(){
    std::string sql = "";
    if (dbConn) {
/*
    	sql = "CREATE TABLE IF NOT EXISTS Organisations ("
              " rowId INTEGER PRIMARY KEY,"
              " orgId INTEGER,"
              " version INTEGER,"
              " name TEXT,"
              " taxId TEXT,"
              " iban TEXT,"
              " swift TEXT,"
              " bank TEXT,"
              " street TEXT,"
              " street2 TEXT,"
              " city TEXT,"
              " zip TEXT,"
              " zipName TEXT,"
              " state TEXT,"
              " phone TEXT,"
              " gsm TEXT,"
              " email TEXT,"
              " www TEXT,"
              " valid INTEGER,"
              " validTill TEXT);";
        dbConn->execQuery(sql);
*/
        sql = "CREATE TABLE IF NOT EXISTS Templates ("
              " rowId INTEGER PRIMARY KEY,"
              " templId INTEGER,"
              " version INTEGER,"
              " name TEXT,"
              " menuLabel TEXT,"
              " showInMenu INTEGER,"
        	  " shortcut TEXT,"
        	  " goalCounter INTEGER,"
              " valid INTEGER,"
              " validTill TEXT);";
        dbConn->execQuery(sql);

/*
        sql = "CREATE TABLE IF NOT EXISTS TemplateRelations ("
              " rowId INTEGER PRIMARY KEY,"
              " templRowId INTEGER,"
        	  " templRowIdParent INTEGER,"
        	  " conditions TEXT,"
              " valid INTEGER,"
              " validTill TEXT);";
        dbConn->execQuery(sql);
*/
        sql = "CREATE TABLE IF NOT EXISTS TemplateColumns ("
              " rowId INTEGER PRIMARY KEY,"
              " columnId INTEGER,"
              " templRowId INTEGER,"
        	  " version INTEGER,"
        	  " enabled INTEGER,"
        	  " uuid TEXT,"
        	  " label TEXT,"
              " libreCode TEXT,"
              " object TEXT,"
        	  " type TEXT,"
        	  " orderWeight INTEGER,"
        	  " options TEXT,"
        	  " defaultValue TEXT,"
        	  " valid INTEGER,"
              " validTill TEXT);";
        dbConn->execQuery(sql);

        sql = "CREATE TABLE IF NOT EXISTS TemplateFiles ("
              " rowId INTEGER PRIMARY KEY,"
              " fileId INTEGER,"
        	  " version INTEGER,"
              " templRowId INTEGER,"
        	  " uuid TEXT,"
              " name TEXT,"
              " path TEXT,"
        	  " valid INTEGER,"
        	  " validTill TEXT);";
        dbConn->execQuery(sql);

        sql = "CREATE TABLE IF NOT EXISTS TemplateData ("
              " rowId INTEGER PRIMARY KEY,"
        	  " dataId INTEGER,"
        	  " version INTEGER,"
        	  " templRowId INTEGER,"
              " valid INTEGER,"
              " validTill TEXT);";
        dbConn->execQuery(sql);

        sql = "CREATE TABLE IF NOT EXISTS TemplateValues ("
              " rowId INTEGER PRIMARY KEY,"
        	  " valueId TEXT,"
        	  " dataRowId INTEGER,"
        	  " version INTEGER,"
        	  " columnRowId INTEGER,"
              " value TEXT,"
        	  " options TEXT,"
              " valid INTEGER,"
              " validTill TEXT);";
        dbConn->execQuery(sql);

        sql = "CREATE TABLE IF NOT EXISTS TemplateDataFiles ("
              " rowId INTEGER PRIMARY KEY,"
              " fileId INTEGER,"
        	  " version INTEGER,"
              " templRowId INTEGER,"
        	  " templFileRowId INTEGER,"
        	  " dataRowId INTEGER,"
        	  " uuid TEXT,"
              " name TEXT,"
              " path TEXT,"
              " valid INTEGER,"
              " validTill TEXT);";
        dbConn->execQuery(sql);


        sql = " UPDATE Settings SET version ='1';";
        dbConn->execQuery(sql);
        DB_VERSION = "1";
    }
}


void UpdateDB::upgrade_v2(){

    if (dbConn) {
    	std::string sql = "";

        sql = "ALTER TABLE Settings ADD COLUMN lang TEXT;";
        dbConn->execQuery(sql);

        std::string langSet = getenv("LANG") == nullptr? "en_" : getenv("LANG");
        if (!langSet.empty()){
        	if (langSet.starts_with("sl_SI")) {
        		langSet ="si";
        	} else if (langSet.starts_with("hr_HR")) {
        		langSet ="hr";
        	} else if (langSet.starts_with("bs_")) {
        		langSet ="bih";
        	} else if (langSet.starts_with("en_")) {
        		langSet ="en";
        	} else if (langSet.starts_with("de_DE")) {
        		langSet ="de";
        	} else if (langSet.starts_with("fr_")) {
        	    langSet ="fr";
        	} else if (langSet.starts_with("it_IT")) {
        		langSet ="it";
        	} else {
        		langSet ="en";
        	}
        }else {
        	langSet = "en";
        }
        sql = "UPDATE Settings SET lang = '" + langSet + "';";
        dbConn->execQuery(sql);

    	sql = " UPDATE Settings SET version ='2';";
        dbConn->execQuery(sql);
        DB_VERSION = "2";
    }

}
