/*
 * SPDX-FileCopyrightText: 2022 Institute Rhea <eduard.filipas@rhea.si>
 *
 * SPDX-License-Identifier: EUPL-1.2
 */

#ifndef MAIN_MAIN_H
#define MAIN_MAIN_H

#include "gtkmm.h"
#include "rhea/WndManager/WndManager.h"
#include "LanguagePack.h"
#include "Global.h"

class Global;

class AppWindow : public Gtk::ApplicationWindow {

private:
	Global* global;
    std::string strAppToolBar = "";
    Gtk::Box* myBox = new Gtk::Box(Gtk::Orientation::HORIZONTAL);
    void on_menu_file_new_generic();
    LanguagePack* lang = LanguagePack::getInstance();

protected:
    Glib::RefPtr<Gtk::Builder> m_refBuilder;
    Gtk::Box* windowBox = new Gtk::Box(Gtk::Orientation::VERTICAL);

public:
    rhea::WndManager* frmMngr = new rhea::WndManager();
    AppWindow();
    ~AppWindow();
    void onMenuTemplates();
    void onMenuSettings();
    void onMenuContent();
    void onMenuAbout();
    void onMenuDataTemplates(Glib::VariantBase data);
};


#endif //MAIN_MAIN_H
