/*
 * SPDX-FileCopyrightText: 2022 Institute Rhea <eduard.filipas@rhea.si>
 *
 * SPDX-License-Identifier: EUPL-1.2
 */

#include "Column.h"

Column::Column() {

}

int Column::getPrecision() {
    return precision;
}

void Column::setPrecision(int precision) {
    this->precision = precision;
}

std::string Column::getValue() {
    switch (type) {
        case ColumnType::Int:
            value = std::to_string(intVal);
            break;
        case ColumnType::Double:
            value = std::to_string(doubleVal);
            break;
        case ColumnType::Date:
            value = std::to_string(dtVal.getDay()) + ". "+ std::to_string(dtVal.getMonth()) + ". " + std::to_string(dtVal.getYear());
            break;
    }
    return value;
}

void Column::setValue(std::string val) {
    type = ColumnType::String;
    value = val;
}

void Column::setValue(int val) {
    type = ColumnType::Int;
    intVal = val;
}

void Column::setValue(double val) {
    type = ColumnType::Double;
    doubleVal = val;
}

void Column::setValue(rhea::DateTime val) {
    type = ColumnType::Date;
    dtVal = val;
}

std::string Column::getDefaultValue(){
	return defaultVal;
}

void Column::setDefaultValue(std::string val){
	defaultVal = val;
}

void Column::clearObject() {

}

Column::~Column() {

}
