/*
 * SPDX-FileCopyrightText: 2022 Institute Rhea <eduard.filipas@rhea.si>
 *
 * SPDX-License-Identifier: EUPL-1.2
 */

#ifndef PO_COLUMN_H_
#define PO_COLUMN_H_

#include "string.h"
#include <vector>
#include "Po.h"

enum ColumnType{
	Int,
    Double,
    String,
    Date,
	Index
};

enum ColumnObject{
    TextView,
    ChkBox,
    Combo,
    Options,
    PckpDT,
	Grid
};


class Column :  public Po {
private:
    std::string value = {""};
    int intVal = {0};
    double doubleVal = {0.00};
    rhea::DateTime dtVal = {};
    int precision = {2};
    std::string defaultVal;

public:
    std::string label = {""};
    std::string libreCode = {""};
    int order = 0;
    ColumnType type = {ColumnType::String};
    ColumnObject objectType = {ColumnObject::TextView};
    std::vector<std::string> options;

    Column();
    ~Column();
    int getPrecision();
    void setPrecision (int precision);
    std::string getValue();
    void setValue (std::string val);
    void setValue (int val);
    void setValue (double val);
    void setValue (rhea::DateTime val);
    std::string getDefaultValue();
    void setDefaultValue(std::string val);
    void clearObject() override;
};


#endif /* PO_COLUMN_H_ */
