/*
 * SPDX-FileCopyrightText: 2022 Institute Rhea <eduard.filipas@rhea.si>
 *
 * SPDX-License-Identifier: EUPL-1.2
 */

#ifndef PO_FILTER_H_
#define PO_FILTER_H_

#include <string>
#include "Column.h"
#include "vector"

enum Operator {
	equal,
	biger,
	bigeq,
	smleq,
	smaller,
	isnt,
	begins,
	ends,
	contains
};

enum WithOperator {
	NONE,
	AND,
	OR
};

struct FilterEntity{
    bool valid = false;
	Column* col = new Column();
	Operator op = Operator::equal;
	std::string value;
};

struct FilterWith{
	FilterEntity* entity = {};
	WithOperator with = WithOperator::NONE;
	FilterWith* next = {nullptr};
};

struct FilterGroup{
	FilterWith* fw = {};
	WithOperator with = WithOperator::NONE;
	FilterGroup * fg = {nullptr};
};

class Filter {
private:
	FilterGroup filter = {};
public:
	Filter();
	virtual ~Filter();
};

#endif /* PO_FILTER_H_ */
