/*
 * SPDX-FileCopyrightText: 2022 Institute Rhea <eduard.filipas@rhea.si>
 *
 * SPDX-License-Identifier: EUPL-1.2
 */

#include "Po.h"

Po::Po() {
    setNewUUID();
}

Po::~Po() {

}

long long int &Po::getRowId() {
    return rowId;
}

void Po::setRowId(long long int rowId) {
    Po::rowId = rowId;
}

long long &Po::getPojoId() {
    return pojoId;
}

void Po::setPojoId(long long int pojoId) {
    Po::pojoId = pojoId;
}

int &Po::getPojoVersion() {
    return pojoVersion;
}

void Po::setPojoVersion(int pojoVersion) {
    Po::pojoVersion = pojoVersion;
}

std::string &Po::getPojoName() {
    return pojoName;
}

void Po::setPojoName( std::string pojoName) {
    Po::pojoName = pojoName;
}

bool &Po::isValid() {
    return valid;
}

void Po::setValid(bool isValid) {
    Po::valid = isValid;
}

void Po::setNewUUID() {
#ifdef WIN32
    UUID uuid;
    UuidCreate ( &uuid );

    unsigned char * str;
    UuidToStringA ( &uuid, &str );

    std::string s( ( char* ) str );

    RpcStringFreeA ( &str );
#else
    uuid_t uuid;
    uuid_generate_random ( uuid );
    char s[37];
    uuid_unparse ( uuid, s );
#endif
    UUID = s;
}

void Po::setUUID(std::string uuid) {
    UUID = uuid;
}

std::string &Po::getUUID() {
    return UUID;
}

void Po::clear() {
    rowId       = initRowId;
    pojoId      = initPoId;
    pojoVersion = initVersion;
    pojoName    = initStr;
    valid       = true;
    clearObject();
}
