/*
 * SPDX-FileCopyrightText: 2022 Institute Rhea <eduard.filipas@rhea.si>
 *
 * SPDX-License-Identifier: EUPL-1.2
 */

#ifndef PO_PO_H
#define PO_PO_H

#include "DefValues.h"
#include "../rhea/DateTime/DateTime.h"
#include "utility"

#ifdef WIN32
#include <Rpc.h>
#else
#include <uuid/uuid.h>
#endif

class Po : protected DefValues {

private:
    long long   rowId            = {initRowId};
    long long   pojoId           = {initPoId};
    int         pojoVersion      = {initVersion};
    std::string UUID             = {initStr};
    std::string pojoName         = {initStr};
    std::string fieldDelimiter   = {"###"};
    bool        valid            = {true};

public:
    rhea::DateTime* validTill = new rhea::DateTime();

    Po();
    ~Po();

    long long &getRowId();
    void setRowId(long long rowId);

    long long &getPojoId();
    void setPojoId(long long pojoId);

    int &getPojoVersion();
    void setPojoVersion(int pojoVersion);

    std::string &getPojoName();
    void setPojoName( std::string pojoName);

    bool &isValid();
    void setValid(bool isValid);

    void setNewUUID();
    void setUUID(std::string uuid);
    std::string &getUUID();

    void clear();
    virtual void clearObject() = 0;
};

#endif //PO_PO_H
