/*
 * SPDX-FileCopyrightText: 2022 Institute Rhea <eduard.filipas@rhea.si>
 *
 * SPDX-License-Identifier: EUPL-1.2
 */

#ifndef PO_TEMPLATE_H
#define PO_TEMPLATE_H

#include "vector"
#include "Po.h"
#include "Column.h"
#include "TemplateFile.h"
#include "DataSection.h"

enum KeyMasks {
	Shift =1,
	Ctrl  =2,
	Alt   =4,
};


class DataSection;

class Template : public Po {
private:
    std::string jsonDef = {""};
    std::string name = {getPojoName()};
    std::string menuLabel = {""};
    std::string shortcut = {""};
    int keyMask = 0;
    bool showInMenu = {true};
    long long goalCount = 0;
public:

    std::vector<Column*> columns;
    std::vector<TemplateFile*> templateFiles;
    std::vector<DataSection*> usingTemplates;
    Template();
    ~Template();
    void clearObject() override;
    std::string getJSON ();
    void setJSON (std::string val);
    std::string getName();
    void setName(std::string str);
    std::string getLabel();
    void setLabel(std::string str);
    void setMenuVisibility(bool val);
    bool getMenuVisibility();
    long long getGoalCount();
    void setGoalCount(long long val);
    std::string getShortCut();
    void getShortCut(int& mask, std::string &key);
    void setShortcut(int mask, std::string key);
};


#endif //PO_TEMPLATE_H
