/*
 * SPDX-FileCopyrightText: 2022 Institute Rhea <eduard.filipas@rhea.si>
 *
 * SPDX-License-Identifier: EUPL-1.2
 */

#ifndef RHEA_COMBOBOX_H
#define RHEA_COMBOBOX_H

#include "gtkmm.h"

namespace rhea {

template <class T>  class ComboBox : public Gtk::ComboBox {
        //Tree model columns:
    private:
        std::function<void(ComboBox *obj, Gtk::TreeRow oldChoice, Gtk::TreeRow newChoice)> onChangeCallback = {nullptr};

        Gtk::TreeRow previousChoice;

        void on_cell_data_extra(const Gtk::TreeModel::const_iterator &iter);
        void on_combo_changed();


        Gtk::CellRendererText cell;

    public:
        T columns;
        Glib::RefPtr<Gtk::ListStore> refTreeModel;

        ComboBox();

        virtual~ComboBox();

        void addList(Glib::RefPtr<Gtk::ListStore> *dataColumns);

        template<typename A, typename B>
        void setOnChange(A funcPtr, B objPtr) { onChangeCallback = std::bind(funcPtr, objPtr, std::placeholders::_1, std::placeholders::_2, std::placeholders::_3);}
    };

}

#include "ComboBox.cpp"

#endif //RHEA_COMBOBOX_H
