/*
 * SPDX-FileCopyrightText: 2022 Institute Rhea <eduard.filipas@rhea.si>
 *
 * SPDX-License-Identifier: EUPL-1.2
 */

#ifndef RHEA_DATETIME_H
#define RHEA_DATETIME_H

#include <ctime>
#include "../../main/LanguagePack.h"
#include "string"
namespace rhea {

    class DateTime {

    private:
        tm timestamp = {0, 0, 0, 0, 0, 0, 0, 0};
    public:
        DateTime();

        DateTime(int day, int month, int year, int hour, int min, int sec);

        ~DateTime();

        std::string getAsISO8601();

        std::string getAsString(Languages lng, int format = 2, int showPart = 3);

        int getDay();

        int getMonth();

        int getYear();

        int getHour();

        int getMin();

        int getSec();

        void set(time_t &theTime);

        void setDate(int day, int month, int year);

        void setTime(int hour, int minute, int sec);

        void setAsISO8601(std::string str);

        void clear();
    };

}

#endif //RHEA_DATETIME_H
