/*
 * SPDX-FileCopyrightText: 2022 Institute Rhea <eduard.filipas@rhea.si>
 *
 * SPDX-License-Identifier: EUPL-1.2
 */

#ifndef RHEA_HEADER_H
#define RHEA_HEADER_H

#include "gtkmm.h"
#include "GridCell.h"

namespace rhea {

class GridHeader : public rhea::GridCell {
private:
    bool showSort = {false};
//    Gtk::Box*  placeholder = new Gtk::Box(Gtk::Orientation::HORIZONTAL);
    Gtk::Image* icon       = new Gtk::Image();
    Gtk::Image* iconSort   = new Gtk::Image();
    Gtk::Label* lblCaption = new Gtk::Label();
//    Gtk::Widget* hdrWidget = {nullptr};

public:
    GridHeader();
    ~GridHeader() override;
    void setCaption(std::string val);
    std::string getCaption();
    void attachWidget(Gtk::Widget* widget, bool showLabel = false);
    Gtk::Widget* getWidget();
    void setIcon(std::string path);
    void setIcon(Gtk::Image* img);
    void setShowSort(bool show = false);
    bool doesShowSort();
    void applyCSS() override;
};

}

#endif //RHEA_HEADER_H
