/*
 * SPDX-FileCopyrightText: 2022 Institute Rhea <eduard.filipas@rhea.si>
 *
 * SPDX-License-Identifier: EUPL-1.2
 */

#ifndef RHEA_PICKUPDT_H
#define RHEA_PICKUPDT_H

#include "gtkmm.h"

namespace rhea {

typedef void (* onGlibDateChangeCallBack_function)(Glib::DateTime, Glib::DateTime);

class PickupDT : public Gtk::Box {

    private:
        int width = 0;
        int height = 0;
        bool shown = false;
        Glib::DateTime oldDate;
        Glib::DateTime newDate;
        Gtk::TextView* text;
        Gtk::Button* btn;
        Gtk::Calendar* calendar;
        Gtk::Popover* popBox;
        onGlibDateChangeCallBack_function onChange = {nullptr};
        void onBtnClicked();
        void on_my_day_selected();

    public:
        PickupDT();
        ~PickupDT();
        Glib::DateTime getDate();
        std::string getAsISO8601();
        void setSize(int width, int height);
        void setValue(Glib::DateTime val);
        void setValue(std::string iso8601);
        void onChangeConnect( onGlibDateChangeCallBack_function pFunc);

    };

}

#endif //RHEA_PICKUPDT_H
