/*
 * SPDX-FileCopyrightText: 2022 Institute Rhea <eduard.filipas@rhea.si>
 *
 * SPDX-License-Identifier: EUPL-1.2
 */

#include "DbAtribute.h"

#include <utility>

rhea::DbAtribute::DbAtribute() = default;

rhea::DbAtribute::~DbAtribute() = default;

std::string rhea::DbAtribute::getAsString() {
    return myStr;
}

void rhea::DbAtribute::setAsString(const std::string val) {
    myStr = val;
    setType(3);
}

int rhea::DbAtribute::getAsInteger() const {
    return (int) myLong;
}

void rhea::DbAtribute::setAsInteger(const int val) {
    myLong = val;
    setType(1);
    myStr = std::to_string(myLong);
}

long long rhea::DbAtribute::getAsLong() const {
    return myLong;
}

void rhea::DbAtribute::setAsLong(const long long int val) {
    myLong = val;
    setType(1);
    myStr = std::to_string(myLong);
}

double rhea::DbAtribute::getAsDouble() const {
    return myDouble;
}

void rhea::DbAtribute::setAsDouble(const double val) {
    myDouble = val;
    setType(2);
    myStr = std::to_string(myDouble);
}

float rhea::DbAtribute::getAsFloat() const {
    return (float)myDouble;
}

void rhea::DbAtribute::setAsFloat(const float val) {
    myDouble = val;
    setType(2);
    myStr = std::to_string(myDouble);
}

unsigned char* rhea::DbAtribute::getAsBlob() const {
    return myBlob;
}

void rhea::DbAtribute::setAsBlob(unsigned char *val) {
    myBlob = val;
    setType(4);
}

int rhea::DbAtribute::getBlogLength() {
    int i=0;
    unsigned char* b = myBlob;
    while( *b ) {
        i++;
        ++b;
    }
    return i;
}
