/*
 * SPDX-FileCopyrightText: 2022 Institute Rhea <eduard.filipas@rhea.si>
 *
 * SPDX-License-Identifier: EUPL-1.2
 */

#ifndef RHEA_DBATRIBUTE_H
#define RHEA_DBATRIBUTE_H

#include "DbAtributeMetaData.h"

namespace rhea {

    class DbAtribute: public DbAtributeMetaData {
    private:
        std::string myStr = {""};
        long long myLong = {0};
        float myDouble = {0.0};
        unsigned char* myBlob = {nullptr};

    public:
        DbAtribute();
        ~DbAtribute();
        std::string getAsString();
        void setAsString(std::string val);
        int getAsInteger() const;
        void setAsInteger(int val);
        long long getAsLong() const;
        void setAsLong(long long val);
        double getAsDouble() const;
        void setAsDouble(double val);
        float getAsFloat() const;
        void setAsFloat(float val);
        unsigned char* getAsBlob() const;
        void setAsBlob(unsigned char* val);
        int getBlogLength();


    };

}
#endif //RHEA_DBATRIBUTE_H

