/*
 * SPDX-FileCopyrightText: 2022 Institute Rhea <eduard.filipas@rhea.si>
 *
 * SPDX-License-Identifier: EUPL-1.2
 */

#include "DbParameters.h"

rhea::DbParameters::DbParameters() {

}

rhea::DbParameters::~DbParameters() {
    params.clear();
}

void rhea::DbParameters::add(std::string value) {
    rhea::DbAtribute attr = rhea::DbAtribute();
    attr.setAsString(value);
    params.push_back(attr);
}

void rhea::DbParameters::add(int value) {
    rhea::DbAtribute attr = rhea::DbAtribute();
    attr.setAsInteger(value);
    params.push_back(attr);
}

void rhea::DbParameters::add(long long value) {
    rhea::DbAtribute attr = rhea::DbAtribute();
    attr.setAsLong(value);
    params.push_back(attr);
}

void rhea::DbParameters::add(float value) {
    rhea::DbAtribute attr = rhea::DbAtribute();
    attr.setAsFloat(value);
    params.push_back(attr);
}

void rhea::DbParameters::add(double value) {
    rhea::DbAtribute attr = rhea::DbAtribute();
    attr.setAsDouble(value);
    params.push_back(attr);
}

std::vector<rhea::DbAtribute>* rhea::DbParameters::get() {
    return &params;
}
